/*
 * adc.h part of XMEGA Oscilloscope
 *
 * Created: 2016-12-16 09:40:36
 * Atmel Studio 6 (Version: 6.2.1563 - Service Pack 2)
 *  Author: Krzysztof Markiewicz
 *  www.obbo.pl
 *
 * This program is distributed under the terms of the GNU General Public License
 */ 

#ifndef ADC_H_
#define ADC_H_

#include <avr/io.h>
#include "input.h"
#include "data.h"

void adc_Init(void);
void adc_InitResolution8bit(void);
void adc_InitResolution12bit(void);
void adc_InitGain(uint8_t ch1gain, uint8_t ch2gain);
void adc_InitTrigered();
void adc_BufferStop(void);
void adc_DMAStart(uint8_t chcfg);
void adc_DMAStop(void);
void adc_DMASet(uint16_t bufferlength, uint8_t chcfg, databuffer_t buffer, uint8_t samplingrate);
int8_t adc_ReadChannel8bit(ADC_t *channel);


#endif /* ADC_H_ */