/*
 * dac.h part of XMEGA Oscilloscope
 *
 * Created: 2016-12-09 22:22:36
 * Atmel Studio 6 (Version: 6.2.1563 - Service Pack 2)
 *  Author: Krzysztof Markiewicz
 *  www.obbo.pl
 *
 * This program is distributed under the terms of the GNU General Public License
 */ 

#ifndef DAC_H_
#define DAC_H_

#include <avr/io.h>
#include <avr/eeprom.h>

#define DAC_OUT_Zero	2048

void dac_Init(void);
void dac_DMAStart(uint16_t *buffer, uint16_t length);
void dac_DMAStop(void);
void dac_BufferStop(void);
void dac_On(void);
void dac_Off(void);
void dac_Calibrate(const uint8_t type, const int8_t step);

#endif /* DAC_H_ */