/*
 * calibration.h part of XMEGA Oscilloscope
 *
 * Created: 2017-01-18 23:07:49
 * Atmel Studio 6 (Version: 6.2.1563 - Service Pack 2)
 *  Author: Krzysztof Markiewicz
 *  www.obbo.pl
 *
 * This program is distributed under the terms of the GNU General Public License
 */

#ifndef CALIBRATION_H_
#define CALIBRATION_H_

#include <avr/eeprom.h>


#define ADC_OFFSET_TAB_LENGTH		(2 * MAIN_CHANNEL_GAIN_RangeOut)

extern int32_t EEMEM adc_offset12CH1[];
extern int32_t EEMEM adc_offset12CH2[];
extern int8_t EEMEM adc_offset8CH1[];
extern int8_t EEMEM adc_offset8CH2[];

// export definition to Xlab oscyloskopx.h
enum calibration_type {
	CALIBRATION_DAC_Offset,
	CALIBRATION_DAC_Gain,
	CALIBRATION_ADC_Clear,
	CALIBRATION_ADC_Auto
};
// end export definition to Xlab oscyloskopx.h

enum adc_error {
	CALIBRATION_ERROR_OutOfRange
};


uint8_t calibration_ADCOffsetCell(uint8_t chcfg, uint8_t chgain);
uint8_t calibration_ADCOffset(void);
void calibration_ADCOffsetClear(uint8_t offset8length, uint8_t offset12length);
uint8_t calibration_ADCOffset12bit(void);
uint8_t calibration_ADCOffset8bit(void);



#endif /* CALIBRATION_H_ */