/*
 * mathasm.c part of XMEGA Oscilloscope
 *
 * Created: 2017-03-25 19:27:21
 * Atmel Studio 6 (Version: 6.2.1563 - Service Pack 2)
 *  Author: Krzysztof Markiewicz
 *  www.obbo.pl
 *
 * This program is distributed under the terms of the GNU General Public License
 */

#include "mathasm.h"


int8_t addsat(int8_t a, int8_t b) {
	asm volatile (
		"add  %0, %1"		"\n\t"
		"brvc 0f"			"\n\t"
		"ldi  %0, 0x7f"		"\n\t"
		"sbrc %1, 7"		"\n\t"
		"ldi  %0, 0x80"		"\n\t"
		"0:"				"\n\t"
		: "+d" (a) 
		: "r" (b));
	return a;
}

int8_t subsat(int8_t a, int8_t b) {
	asm volatile (
		"sub  %0, %1"		"\n\t"
		"brvc 0f"			"\n\t"
		"ldi  %0, 0x80"		"\n\t"
		"sbrc %1, 7"		"\n\t"
		"ldi  %0, 0x7f"		"\n\t"
		"0:"				"\n\t"
		: "+d" (a) 
		: "r" (b));
	return a;
}

int16_t average15( int16_t a, int16_t b) {
    asm volatile (
	    "adc %A[a], %A[b]   \n\t"
	    "adc %B[a], %B[b]   \n\t"
	    "asr %B[a]          \n\t"
	    "ror %A[a]          \n\t"
	    : [a] "+a" (a) 
		: [b] "a"  (b) );
	return a;
}

int8_t fmuls8(int8_t a, int8_t b) {
	int8_t r;
	
	asm volatile (
		"fmuls %[a], %[b]"    "\n\t"
		"mov   %[r], R1"      "\n\t"
		"clr    __zero_reg__"
		: [r] "=r" (r)
		: [a] "a" (a),  [b] "a" (b) );
	return r;
}

