/*
 * mso.h part of XMEGA Oscilloscope
 *
 * Created: 2016-12-16 09:41:22
 * Atmel Studio 6 (Version: 6.2.1563 - Service Pack 2)
 *  Author: Krzysztof Markiewicz
 *  www.obbo.pl
 *
 * This program is distributed under the terms of the GNU General Public License
 */ 


#ifndef MSO_H_
#define MSO_H_

#include <stdint.h>
#include <avr/eeprom.h>
#include <avr/pgmspace.h>
#include <stdbool.h>
#include "data.h"


enum mso_error {
	MSO_ERROR_CaptureTimeout
};


void mso_ConfigApply(config_t *mainconfig, uint8_t samplingrate);
void mso_WaitForSampleComplet(uint8_t samplingrate);
void mso_DMALogicChannelDelay(uint8_t samplingrate, uint8_t delay);
uint8_t mso_CaptureBufferPreTrigger(uint8_t samplingrate, uint8_t chbuffersize);
void mso_WaitForTriger(config_t *cfg, uint8_t chcfg, uint8_t trigger, uint8_t source, uint8_t samplingrate, channela_t *channel1, channela_t *channel2, uint8_t ch1ctrl, uint8_t ch2ctrl, uint8_t chdctrl);
void mso_TriggerHold(uint16_t value);
void mso_BufferDateCalculate(uint16_t index, 
							 uint16_t length, 
							 uint8_t chcfg, 
							 uint8_t ch1cfg, 
							 uint8_t ch2cfg, 
							 uint8_t chdcfg, 
							 databuffer_t datain, 
							 usbbuffer_t dataout);
void mso_DMASamplingStart(uint8_t samplingrate);
void mso_DisableAutoTrigger(void);
uint16_t mso_DMARestToTransfer(uint8_t chctrl);
void mso_SlowSamplingStart(void);
void mso_SlowSamplingStop(void);
void mso_DMASamplingStop(void);
void mso_TimersStop(void);
void mso_Stop(void);


#endif /* MSO_H_ */
